# Introduction

The Footnotes module is used to easily create automatically numbered footnote references in an article or post 
(such as a reference to a URL). It provides a toolbar icon which opens up
a modal window which contains its own toolbar allowing the user to
add bold, italics, and links (for example) within a footnote source. It automatically
creates citations and footnotes, along with links and backlinks to allow the user
to jump back and forth between the text and the source.

* For a full description of the module, visit the project page: https://www.drupal.org/project/footnotes
* To submit bug reports and feature suggestions, or track changes: https://www.drupal.org/project/issues/footnotes

# Installation

* Install the module as you would normally install a contributed Drupal module. Visit
  https://www.drupal.org/docs/extending-drupal/installing-modules for further information.

# Configuration

* To use the footnotes filter in some input formats, go to Configuration -> Text formats.
* Drag the footnotes toolbar icon into the active toolbar
* Enable the Footnotes Filter and ensure it appears prior to 'Correct faulty and chopped off HTML' and 'Limit allowed 
  HTML tags and correct faulty HTML' (if enabled).

## Grouping together multiple formatted texts into a single footnote reference area

To group together multiple footnotes into a block, use the Footnotes Group block.

* Ensure that the block appears after the 'Main page content' block
* Set 'Current entity context for caching' to 'node' to ensure no caching issues
* Check the 'Disable output of the footnotes footer' option in the Filter configuration (Configuration -> Text formats).

If you have content loaded via lazy builder, the footnotes may not all show
up via the PHP-based method. In that case:

* Un-check the 'Disable output of the footnotes footer' option in the Filter configuration (Configuration -> Text 
  formats).
* Check the 'Group footnotes using JavaScript' option in the block configuration.

Note that if footnotes are manually numbered 1,2,1,2 they 
will not be renumbered when combined. The footnote values
will only be renumbered if the values are left blank: ie,
the numbering was generated by automated numbering.

## Collapsing identical footnotes into the same number

If you have two citations citing an identical source:

* Ensure that the source 'content' is identical
* Check the 'Collapse footnotes with identical content' option in the Filter configuration (Configuration -> Text 
  formats).

## Editing available options in the footnotes modal window

The footnotes modal window is controlled in Configuration > Text Formats > Footnotes. Note
that Drupal Core does not support Modal Windows within Modal Windows, so Media is therefore
not supported within a Footnote. Bubble dialogs are supported, so things like Link will
work fine (and Link is enabled by default).

# Theming

Copy the templates into your theme as needed and clear
the theme-registry cache (`drush cc theme-registry`).

* `footnote-link.html.twig` : The individual citation.
* `footnote-links.html.twig` : Multiple citations directly next to each other. Use this to for
  example do [1-3] instead of [1][2][3].
* `footnote-list.html.twig` : The footnote references output after the text (or in the footnotes
  group block).

# Upgrading from 3x

First run `drush updb`.

Then use the Drush Commands provided **at own risk**: test thoroughly before
applying to any production/live environment.

Examples:
```bash
drush footnotes:upgrade-3-to-4 node
drush footnotes:upgrade-3-to-4 paragraph
drush footnotes:upgrade-3-to-4 block
drush footnotes:upgrade-3-to-4 taxonomy_term
drush footnotes:upgrade-3-to-4 your_custom_entity_type
```

# Debugging pasting from Word or elsewhere

1. Add a query string variable 'debug' to the URL like /node/add/page?debug=1
2. Paste into the CK Editor
3. View the console output
